local AddonName, a = ...
if a.BuildFail(50000) then return end
local L = a.Localize
local s = SpellFlashAddon
local x = s.UpdatedVariables
local talent = x.Talent
local target = x.Target
local buff = x.Buff
local equipped = x.Equipped 
local cooldown = x.Cooldown

-- SpellFlash API:
-- http://wow.curseforge.com/addons/spellflash/pages/api/

-- Updated variable references:
-- http://wow.curseforge.com/addons/spellflash/pages/api/#w-local-x-spell-flash-addon-updated-variables
-- x.Enemy, x.ActiveEnemy, x.NoCC, x.InInstance, x.InstanceType, x.PetAlive, x.PetActiveEnemy, x.PetNoCC, x.Lag, x.DoubleLag, x.ThreatPercent, x.EnemyDetected, x.ShouldPermanentBuff, x.ShouldTemporaryBuff


-- Use this single spam function and remove the multiple spam table below, or just use the multiple spam table below and leave this function in place.
a.SetSpamFunction(function() a.RunSpamTable()
	s.UpdateTarget()
	s.UpdateBloodlust()
	x.Chi = s.Power("player", Enum.PowerType.Chi )
	x.MaxChi = s.MaxPower("player", Enum.PowerType.Chi)
	x.InCombat = s.InCombat()
	x.Spec = s.TalentMastery()
	x.ActiveEnemies = s.SpellTargets()
	x.MaxHealth = s.MaxHealth("player")
	a.Flash("Spear Hand Strike", "Paralysis", "Leg Sweep as Interrupt") -- interrupt casters
	x.Haste = 1 + UnitSpellHaste("player")/100
	x.MaxGCD = 1.5 / x.Haste

	if x.MaxGCD < 1 then
		x.MaxGCD = 1
	end

	x.UseLongCD = x.InCombat and (s.Boss("target") or x.InstanceType == "pvp" or x.InstanceType == "arena" or (tostring(UnitClassification("target")):lower():match("elite") and x.InstanceType == "none"))

	if x.Spec == 1 then
		-- Brewmaster
		x.MaxEnergy = s.MaxPower("player", Enum.PowerType.Energy)
		x.Energy = math.min(s.Power("player", Enum.PowerType.Energy ) + s.GlobalCooldown() * s.PowerRegeneration(), x.MaxEnergy)
		x.EnergyRegen = s.PowerRegeneration()
		x.Stagger.heavy = s.Debuff(124273--[[Heavy Stagger]], "player") 
		x.Stagger.moderate = s.Debuff(124274--[[Moderate Stagger]], "player")
		x.Stagger.light = s.Debuff(124275--[[Light Stagger]], "player")
		s.UpdateCooldown(119582, "brews")
		if talent.light_brewing.enabled then
			x.Cooldown.brews.max_charges = 4
		else
			x.Cooldown.brews.max_charges = 3
		end
		s.UpdateBuff(120954, "Fortifying Brew")
		s.UpdateBuff(122278, "Dampen Harm")
		s.UpdateBuff(228563, "Blackout Combo")
		s.UpdateBuff(115308, "Ironskin Brew")
		s.UpdateDoT(123725, "Breath of Fire")
		s.UpdateCooldown(121253, "Keg Smash")
		s.UpdateBuff(116768, "BoK Proc")
		a.Flash("Roll") -- if we are not in range, use these
		a.Flash("Provoke") -- taunt if tanking and not keeping aggro
		a.Flash("auto_attack",
				"gift_of_the_ox",
				"dampen_harm,if=incoming_damage_1500ms&buff.fortifying_brew.down",
				"fortifying_brew,if=incoming_damage_1500ms&(buff.dampen_harm.down|buff.diffuse_magic.down)",
--				"use_item,name=archimondes_hatred_reborn",
--				"potion",
--				"blood_fury",
--				"berserking",
--				"lights_judgment",
				"invoke_niuzao_the_black_ox,if=target.time_to_die>45",
				"purifying_brew,if=stagger.heavy|(stagger.moderate&cooldown.brews.charges_fractional>=cooldown.brews.max_charges-0.5&buff.ironskin_brew.remains>=buff.ironskin_brew.duration*2.5)",
				-- About charge management, by default while tanking (always true on SimC) we lower it by 1 and up to 1.5 if we are tanking with less than half of Ironskin base duration up.
				"ironskin_brew,if=buff.blackout_combo.down&cooldown.brews.charges_fractional>=cooldown.brews.max_charges-0.1-(1+buff.ironskin_brew.remains<=buff.ironskin_brew.duration*0.5)&buff.ironskin_brew.remains<=buff.ironskin_brew.duration*2",
				"black_ox_brew,if=incoming_damage_1500ms&stagger.heavy&cooldown.brews.charges_fractional<=0.75",
				"black_ox_brew,if=(energy+(energy.regen*cooldown.keg_smash.remains))<40&buff.blackout_combo.down&cooldown.keg_smash.up",
--				"arcane_torrent,if=energy<31",
				"keg_smash,if=spell_targets>=3",
				"tiger_palm,if=buff.blackout_combo.up",
				"keg_smash",
				"blackout_strike",
				"breath_of_fire,if=buff.blackout_combo.down&(buff.bloodlust.down|(buff.bloodlust.up&&dot.breath_of_fire_dot.refreshable))",
				"rushing_jade_wind",
				"chi_burst",
				"chi_wave",
				"tiger_palm,if=!talent.blackout_combo.enabled&cooldown.keg_smash.remains>gcd&(energy+(energy.regen*(cooldown.keg_smash.remains+gcd)))>=55")

	elseif x.Spec == 2 then
		-- Mistweaver
		a.Flash("Roll")
	elseif x.Spec == 3 then
		-- Windwalker
		x.MaxEnergy = s.MaxPower("player", Enum.PowerType.Energy)
		x.Energy = math.min(s.Power("player", Enum.PowerType.Energy ) + s.GlobalCooldown() * s.PowerRegeneration(), x.MaxEnergy)
		x.EnergyRegen = s.PowerRegeneration()
		x.EnergyTimeToMax = (x.MaxEnergy - x.Energy) / x.EnergyRegen

		a.Flash("Roll")

		s.UpdateBuff(21191, "Serenity")
		s.UpdateBuff(137639, "Storm, Earth, and Fire")
--[[		a.Flash(-- Touch of Karma on cooldown, if Good Karma is enabled equal to 100% of maximum health
				"touch_of_karma,interval=90,pct_health=0.5,if=!talent.Good_Karma.enabled,interval=90,pct_health=0.5"
				,"touch_of_karma,interval=90,pct_health=1.0"
				-- Potion if Serenity or Storm, Earth, and Fire are up or you are running serenity and a main stat trinket procs, or you are under the effect of bloodlust, or target time to die is greater or equal to 60
				,"potion,if=buff.serenity.up|buff.storm_earth_and_fire.up|(!talent.serenity.enabled&trinket.proc.agility.react)|buff.bloodlust.react|target.time_to_die<=60"
				) ]]
--		if a.Flash("touch_of_death,if=target.time_to_die<=9") then return end

		s.UpdateCooldown(21191, "Serenity")
		s.UpdateCooldown(137639, "Storm, Earth, and Fire")
		s.UpdateCooldown(113656, "Fists of Fury")
		s.UpdateCooldown(107428, "Rising Sun Kick")
		s.UpdateCooldown(115080, "Touch of Death")
		-- Call the Serenity action list if you're using Serenity and Serenity is available (or you're currently in Serenity)
		--,"call_action_list,name=serenity,if=(talent.serenity.enabled&cooldown.serenity.remains<=0)|buff.serenity.up"
		if x.UseLongCD and ((talent.serenity.enabled and cooldown.serenity.remains <= 0) or buff.serenity.up) then
			-- Actions.Serenity
			if a.FlashSerenity() then return end
		end

		-- Call the SEF action list if you're using SEF and are currently in SEF or have 2 SEF stacks
		--,"call_action_list,name=sef,if=!talent.serenity.enabled&(buff.storm_earth_and_fire.up|cooldown.storm_earth_and_fire.charges=2)"
		if x.UseLongCD and (not talent.serenity.enabled and (buff.storm_earth_and_fire.up or cooldown.storm_earth_and_fire.charges == 2)) then
			if a.FlashSEF() then return end
		end
		-- Call the SEF action list if you're not using Serenity and:
		-- - FoF cd <= 12
		-- - Chi >= 3
		-- - RSK cd >= 1
		-- OR the target will die within 25 seconds OR ToD is on the target
		--,"call_action_list,name=sef,if=(!talent.serenity.enabled&cooldown.fists_of_fury.remains<=12&chi>=3&cooldown.rising_sun_kick.remains<=1)|target.time_to_die<=25|cooldown.touch_of_death.remains>112"
		if x.UseLongCD and ((not talent.serenity.enabled and cooldown.fists_of_fury.remains <= 12 and x.Chi >= 3 and cooldown.rising_sun_kick.remains <= 1) or target.time_to_die <= 25 or cooldown.touch_of_death.remains > 112) then
			if a.FlashSEF() then return end
		end
		-- Call the SEF action list if you're using Serenity and:
		-- - Using DHC
		-- - FoF cd <= 6
		-- - Chi >= 3
		-- - RSK cd <= 1
		-- OR the target will die within 15 seconds OR ToD is on the target and you have 1 stack of SEF
		--,"call_action_list,name=sef,if=(!talent.serenity.enabled&!equipped.drinking_horn_cover&cooldown.fists_of_fury.remains<=6&chi>=3&cooldown.rising_sun_kick.remains<=1)|target.time_to_die<=15|cooldown.touch_of_death.remains>112&cooldown.storm_earth_and_fire.charges=1"
		if x.UseLongCD and ((not talent.serenity.enabled and not equipped.drinking_horn_cover and cooldown.fists_of_fury.remains <= 6 and x.Chi >= 3 and cooldown.rising_sun_kick.remains <= 1) or target.time_to_die <= 15 or cooldown.touch_of_death.remains > 112 and cooldown.storm_earth_and_fire.charges == 1) then
			if a.FlashSEF() then return end
		end
		-- Exactly the same as previous line, but with an added check whether you have 1 stack of SEF
		--,"call_action_list,name=sef,if=(!talent.serenity.enabled&cooldown.fists_of_fury.remains<=12&chi>=3&cooldown.rising_sun_kick.remains<=1)|target.time_to_die<=25|cooldown.touch_of_death.remains>112&cooldown.storm_earth_and_fire.charges=1"
		if x.UseLongCD and ((not talent.serenity.enabled and cooldown.fists_of_fury.remains <= 12 and x.Chi >= 3 and cooldown.rising_sun_kick.remains <= 1) or target.time_to_die <= 25 or cooldown.touch_of_death.remains > 112 and cooldown.storm_earth_and_fire.charges == 1) then
			if a.FlashSEF() then return end
		end

		-- Call the AoE action list if there are more than 3 enemies
		--,"call_action_list,name=aoe,if=active_enemies>3"
		if x.ActiveEnemies > 3 then
			a.FlashAoE()
		else
		-- Call the ST action list if there are 3 or less enemies
		--,"call_action_list,name=st,if=active_enemies<=3"
			a.FlashSingleTarget()
		end
	end
end)
